]> rtime.felk.cvut.cz Git - can-benchmark.git/blob - gw-tests/lib.sh
4c4274d301d8ec8576b57b8263ec0aa2c37a8fc9
[can-benchmark.git] / gw-tests / lib.sh
1 set -e
2
3 COUNT=10000
4
5 OPT_TRAFFIC=oneatatime
6
7 error() {
8     echo $1 >&2
9     exit 1
10 }
11
12 while [ $# -gt 0 ]; do
13     case "$1" in
14         -P|--no-plot) OPT_PLOT_DISABLE=1; shift;;
15         -p|--plot) OPT_PLOT_ONLY=1; shift;;
16         -X|--no-x11-plot) OPT_NO_X11=1; shift;;
17         -t) case "$2" in
18                 all|flood|50|oneatatime) OPT_TRAFFIC=$2;;
19                 *) error "Unknown traffic specification: $2";;
20             esac;
21             shift 2;;
22     esac
23 done
24
25 PATH=$PWD/../_compiled/bin/:$PATH
26
27 sshgw() {
28     local socket="$HOME/.ssh/cangw-connection"
29
30     if [[ ! -S $socket ]] || ! ssh -x -a -S $socket root@192.168.2.3 true; then
31         # Create master connection to speed up subsequenct command.
32         # The ssh is put into background and the connection is closed
33         # after 10 minutes)
34         ssh -f -M -S $socket root@192.168.2.3 sleep 600 > /dev/null 2>&1
35     fi
36     ssh -x -a -S $socket root@192.168.2.3 "$@"
37 }
38
39 cleanupgw() {
40     sshgw 'cangw -F'
41 }
42
43 _plot() {
44     local testname=`basename $0 .sh`
45
46     plot_cmds | sed -e "/set title/ s/[\"']\(.*\)[\"']/\"\1\\\\n($kvers)\"/" > plot.gp
47     if [[ ! -s plot.gp ]]; then return; fi
48     if [ -z "$OPT_NO_X11" ]; then
49         echo "set terminal x11 enhanced; $(< plot.gp)" | gnuplot -persist
50     fi
51     I=''
52     echo 'set terminal postscript color eps enhanced size 6cm,4cm lw 1 "Times-Roman" 10;' \
53         'set lmargin 8;' \
54         "$(< plot.gp)" | gnuplot > ${testname}$I.eps
55     echo "set terminal postscript color eps enhanced;" \
56         "$(< plot.gp)" | gnuplot | epstopdf --filter > ${testname}$I.pdf
57     mkdir -p thumb
58     convert -density 30  -gamma 0.5 -quality 90 -type Palette -depth 8 ${testname}$I.pdf thumb/${testname}$I.png
59     convert -density 150 -gamma 0.7 -quality 90 -type Palette -depth 8 ${testname}$I.pdf ${testname}$I.png
60
61 }
62
63 echo_plot() {
64     plot=$1
65     [[ "$_plot_separator" ]] && echo ", \\"
66     _plot_separator=t
67     echo -n "    " $plot
68 }
69
70 traffic_and_length() {
71     local opts
72     case $traffic in
73         flood) opts='';;
74         50)        opts="-p $((2*(44+$1*8)))";;
75         oneatatime)        opts="-o";;
76         *) error "Unknown traffic specification"
77     esac
78     echo $opts -l $1
79 }
80
81 _measure() {
82     # Remove data from the last measurement
83     rm -rf *
84     touch .results
85     cat > plot.sh <<-EOF
86         #!/bin/bash
87         export kvers=$kvers
88         export hostkvers=$hostkvers
89         export traffic=$traffic
90         cd \$(dirname \$0)/$(dirname $script)
91         exec ./$(basename $script) --plot "\$@"
92         EOF
93     chmod +x plot.sh
94     # Set can interfaces up
95     sshgw 'for i in 0 1; do ip link show dev can$i|grep -q UP || ip link set can$i up type can bitrate 1000000; done'
96     # Delete all vcan interfaces
97     sshgw 'for dev in $(ip l|grep -o vcan[^:]\\+); do ip link del dev $dev; done'
98     # Reset priorities
99     sshgw 'if pid=`pidof irq/145-can0`; then chrt -p -f 50 $pid > /dev/null; fi'
100     sshgw 'if pid=`pidof irq/146-can1`; then chrt -p -f 50 $pid > /dev/null; fi'
101     sshgw 'if pid=`pidof sirq-net-rx/0`; then chrt -p -f 49 $pid > /dev/null; fi'
102     sshgw 'if pid=`pidof sirq-net-tx/0`; then chrt -p -f 49 $pid > /dev/null; fi'
103     # Set the length of qdisc queue to avoid ENOBUFS errors
104     ifconfig can0 txqueuelen 200
105     cleanupgw
106     
107     main
108 }
109
110
111 _run() {
112     if [[ $OPT_TRAFFIC = all ]]
113     then traffics="flood 50 oneatatime"
114     else traffics=${traffic:-$OPT_TRAFFIC}
115     fi
116     hostkvers=${hostkvers:-host-$(uname -r)}
117     kvers=${kvers:-$(sshgw uname -r)}
118     test=$(basename $0 .sh)
119     for traffic in $traffics; do
120         dir="results/$hostkvers/$kvers/$traffic/$test"
121         mkdir -p $dir
122         script=$(echo $dir | sed -e 's/[^/]*/../g')/${test}.sh
123         cd $dir
124         echo "Working directory: $dir"
125         if [[ ! "$OPT_PLOT_ONLY" ]]; then
126             _measure
127         fi
128         if [[ ! "$OPT_PLOT_DISABLE" ]]; then
129             _plot
130         fi
131         cd - > /dev/null
132     done
133 }
134
135 test_end() {
136     test_end_called=t
137     exit_ok=
138     _run
139     exit_ok=t
140 }
141
142 _myexit() {
143     code=$?
144     cmd=$BASH_COMMAND
145     if [[ ! "$test_end_called" ]]; then
146         test_end_called=t
147         error "bug in the test script: No test_end called"
148     fi
149     if ! test -n "$exit_ok"; then
150         error "FATAL: Command '$cmd' exit with code $code"
151     fi
152 }
153
154 trap '_myexit' EXIT